#
# Conditional build:
%bcond_without	system_libgit2		# use system installed libgit2

Summary:	Helper program to build and install C-like libraries
Summary(pl.UTF-8):	Program pomocniczy do budowania i instalowania bibliotek w stylu C
Name:		cargo-c
Version:	0.10.7
Release:	1
License:	MIT
Group:		Development/Tools
#Source0Download: https://github.com/lu-zero/cargo-c/releases
Source0:	https://github.com/lu-zero/cargo-c/archive/v%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	cae2d454deecddfcad82732abba982ab
# cd %{name}-%{version}
# cargo vendor
# cd ..
# tar cJf cargo-c-crates-%{version}.tar.xz %{name}-%{version}/{vendor,Cargo.lock}
Source1:	%{name}-crates-%{version}.tar.xz
# Source1-md5:	a8bf8aa772e664c749a54fffd97182e6
URL:		https://github.com/lu-zero/cargo-c
BuildRequires:	cargo >= 0.45
BuildRequires:	curl-devel
%if %{with system_libgit2}
BuildRequires:	libgit2-devel < 1.9.0
BuildRequires:	libgit2-devel >= 1.8.1
%endif
BuildRequires:	libssh2-devel
BuildRequires:	openssl-devel
BuildRequires:	pkgconfig
BuildRequires:	rpmbuild(macros) >= 2.005
BuildRequires:	rust >= 1.78
BuildRequires:	tar >= 1:1.22
BuildRequires:	xz
BuildRequires:	zlib-devel
%{?with_system_libgit2:Requires:	libgit2 >= 1.8.1}
ExclusiveArch:	%{rust_arches}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_enable_debug_packages	0

%description
Cargo subcommands to build and install C-ABI compatible dynamic and
static libraries.

%description -l pl.UTF-8
Podpolecenia Cargo do budowania i instalowania zgodnych z ABI C
bibliotek dynamicznych i statycznych.

%prep
%setup -q -b1

# bundled:
# curl 7.83.1 vendor/curl-sys/curl
# libgit2 1.5.0-alpha vendor/libgit2-sys/libgit2
# nghttp2 1.45.0 vendor/libnghttp2-sys/nghttp2 (but system nghttp2 is not supported in rust)
# libssh 1.10-dev vendor/libssh2-sys/libssh2
# zlib 1.2.11 vendor/libz-sys/src/zlib

# use our offline registry
export CARGO_HOME="$(pwd)/.cargo"

mkdir -p "$CARGO_HOME"
cat >.cargo/config <<EOF
[source.crates-io]
replace-with = 'vendored-sources'

[source.vendored-sources]
directory = '$PWD/vendor'
EOF

%build
export CARGO_HOME="$(pwd)/.cargo"
export LIBSSH2_SYS_USE_PKG_CONFIG=1

%cargo_build --frozen

%install
rm -rf $RPM_BUILD_ROOT
export CARGO_HOME="$(pwd)/.cargo"
export LIBSSH2_SYS_USE_PKG_CONFIG=1

%cargo_install --frozen \
	--path . \
	--root $RPM_BUILD_ROOT%{_prefix}

%{__rm} $RPM_BUILD_ROOT%{_prefix}/.crates*

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc LICENSE README.md
%attr(755,root,root) %{_bindir}/cargo-capi
%attr(755,root,root) %{_bindir}/cargo-cbuild
%attr(755,root,root) %{_bindir}/cargo-cinstall
%attr(755,root,root) %{_bindir}/cargo-ctest
%changelog
* Sat Dec 14 2024 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/cargo-c.git;a=log;h=master

* Fri Dec 06 2024 Jan Palus <atler@pld-linux.org> ae8d520
- up to 0.10.7

* Mon Oct 21 2024 Jan Palus <atler@pld-linux.org> 5a3cd5b
- up to 0.10.5

* Sun Sep 08 2024 Jan Palus <atler@pld-linux.org> 19890f3
- up to 0.10.4

* Sun Aug 11 2024 Jakub Bogusz <qboosh@pld-linux.org> 5206b85
- updated rust version

* Tue Jul 30 2024 Jan Palus <atler@pld-linux.org> 619def2
- up to 0.10.3

* Mon Jun 17 2024 Jan Palus <atler@pld-linux.org> c004cde
- up to 0.10.0

* Sat May 04 2024 Jan Palus <atler@pld-linux.org> 2804f65
- up to 0.9.32

* Sat Mar 23 2024 Jan Palus <atler@pld-linux.org> 7f0ccbb
- disable debug packages

* Sat Mar 23 2024 Jan Palus <atler@pld-linux.org> 308516b
- use %cargo* macros

* Sat Mar 23 2024 Jan Palus <atler@pld-linux.org> f0becba
- up to 0.9.31

* Tue Feb 13 2024 Jan Palus <atler@pld-linux.org> 9c915b7
- up to 0.9.30

* Fri Dec 29 2023 Jan Palus <atler@pld-linux.org> dee8078
- up to 0.9.29

* Tue Nov 21 2023 Jan Palus <atler@pld-linux.org> d82d734
- up to 0.9.28

* Mon Nov 20 2023 Jan Palus <atler@pld-linux.org> 7f0eaa4
- add system_libgit2 bcond

* Mon Nov 20 2023 Jan Palus <atler@pld-linux.org> ec7bbe1
- add upper bound of system libgit2

* Thu Nov 16 2023 Jan Palus <atler@pld-linux.org> 2960dc0
- up to 0.9.27

* Fri Aug 25 2023 Jan Palus <atler@pld-linux.org> a51668f
- up to 0.9.23

* Sun Jul 23 2023 Jan Palus <atler@pld-linux.org> a29e190
- use %{rust_arches} for EA:

* Sun Jul 23 2023 Jan Palus <atler@pld-linux.org> 102ccf6
- BRs for tar.xz source

* Sun Jul 23 2023 Jan Palus <atler@pld-linux.org> 73ce5ff
- macros for %_debugsource_packages

